---
stages:
  - tox
  - documentation
  - sonarqube
  - trigger_jenkins_build
include:
  - docs/.gitlab-ci.yml

####################################  tox   -   Testing and linting
run-tox-pipeline:
  stage: tox
  tags:
    - docker-executor
  image: python:3.12

  services:
    - postgres:15.4


  # Change pip's cache directory to be inside the project directory since we can
  # only cache local items.
  variables:
    POSTGRES_DB: gso-test-db
    POSTGRES_USER: nwa
    POSTGRES_PASSWORD: nwa
    DATABASE_URI_TEST: 'postgresql://nwa:nwa@postgres:5432/gso-test-db'
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

  # Pip's cache doesn't store the python packages
  # https://pip.pypa.io/en/stable/topics/caching/
  #
  # If you want to also cache the installed packages, you have to install
  # them in a virtualenv and cache it as well.
  cache:
    paths:
      - .cache/pip

  before_script:
    - pip install virtualenv
    - virtualenv venv
    - . venv/bin/activate

  script:
    - pip install tox
    - tox

  artifacts:
    paths:
      - htmlcov

sonarqube:
  stage: sonarqube
  image: sonarsource/sonar-scanner-cli
  script:
    - sonar-scanner -Dsonar.login=$SONAR_TOKEN -Dproject.settings=./sonar.properties
  tags:
    - docker-executor

trigger_jenkins_build:
  stage: trigger_jenkins_build
  image: alpine:latest
  before_script:
    - apk add --no-cache curl
  script: curl -u "$JENKINS_USERNAME:$JENKINS_API_TOKEN"
    --data "PROJECT=geant-service-orchestrator"
    "http://test-swd-release-service01.geant.org:8080/job/build-python-snapshot/buildWithParameters"
  only:
    - develop
  tags:
    - docker-executor
